<template>
  <div :class="$style.formUpload">
    <!-- Field Input -->
    <input
      :class="$style.formUploadInput"
      type="file"
      :id="name"
      :filename="value"
      @change="handleFileChange"
      accept="image/*, application/pdf"
    />
    <!-- Field Custom Upload -->
    <label :class="computedClass" :for="name">
      <span v-html="labelTitle" />
    </label>
  </div>
</template>

<script>
import StyleButton from '@/assets/scss/components/_button.module.scss'

export default {
  name: "MeFormUpload",
  model: {
    prop: "value",
    event: "change"
  },
  props: {
    name: {
      type: String,
      required: true
    },
    title: {
      type: String,
      required: true
    },
    value: {
      required: false
    }
  },
  data () {
    return {
      hasFile: false
    }
  },
  computed: {
    computedClass () {
      return [
        StyleButton.btn,
        // Control the status of color button on select a file
        !this.hasFile ? StyleButton.btnYellow : StyleButton.btnGreen
      ]
    },
    labelTitle() {
      /* Return name file or default title from input */
      const file = this.value;

      if (file && typeof file === "object" && file.name) {
        const fileName = file.name;
        const fileExtension = fileName.split('.').pop();
        return fileName.length > 15 ? `${fileName.substring(0, 15)}...${fileExtension}` : fileName;
      } else {
        return `<i class="fa fa-upload mr-2" aria-hidden="true"></i> ${this.title}`;
      }
    }
  },
  methods: {
    handleFileChange(event) {
      this.hasFile = true
      this.$emit("change", event.target.files[0]);
    }
  }
};
</script>

<style lang="scss" module>
.formUpload {
  position: relative;
  display: block;
  width: 100%;
  min-height: 35px;

  // Hide the original input upload
  & > &Input {
    width: 0.1px;
    height: 0.1px;
    opacity: 0;
    overflow: hidden;
    position: absolute;
    z-index: -1;

    &:focus + label {
      box-shadow: 0 0 0 3px rgba(darken($color-yellow-jonquil, 15%), 0.75);
    }
  }
}
</style>
